#!/usr/bin/python
# -*- coding: utf-8 -*-

import re, xbmcplugin, xbmcgui, requests, urllib
import xbmc
import xbmcaddon
import os
import urlparse
from urllib import quote, unquote_plus, unquote, urlencode, quote_plus, urlretrieve

pluginname = 'LibreElec Testbuild Updater'
pluginhandle = int(sys.argv[1])
addon = xbmcaddon.Addon(id='plugin.program.libreelec_testbuild_updater')
downloadpath = addon.getSetting('download_path')
devicetype = addon.getSetting('device_type')
home = addon.getAddonInfo('path').decode('utf-8')


class StopDownload(Exception):
    pass

def categories():
    data = getData("http://milhouse.libreelec.tv/builds/master/%s/" % devicetype)
    builds = re.findall('<tr><td><a href="(.*?)">(.*?)</a></td><td>(.*?)</td><td>(.*?)</td></tr>', data)
    if builds:
        builds.reverse()
        for link,name,size,date in builds:
            link = "http://milhouse.libreelec.tv/builds/master/%s/%s" % (devicetype, link)
            addDir(name, link, 'download', '')
        xbmcplugin.setContent(pluginhandle, 'files')
    else:
        dialog = xbmcgui.Dialog()
        dialog.ok(pluginname, 'Plugin Fehler !', '', '')

def download(url, name):
    if downloadpath is '':
        dialog = xbmcgui.Dialog()
        dialog.ok(pluginname, 'Du hast kein Download Verzeichnis gesetzt', '', '')
        addon.openSettings(sys.argv[0])
    else:
        dialog = xbmcgui.DialogProgress()
        dialog.create(pluginname, "Downloading File", url)
        xbmc.log("Test-Build-Updater: Downloading File "+url, 2)
        try:
            urllib.urlretrieve(url, downloadpath+name, lambda nb, bs, fs, url=url: _reporthook(nb,bs,fs,url,name,dialog))
        except StopDownload:
            xbmc.log("Test-Build-Updater: Download Stopped !", 2)

def _reporthook(numblocks, blocksize, filesize, url, name, dialog):
    percent = min((numblocks*blocksize*100)/filesize, 100)
    dialog.update(percent, 'Downloading.. %s %%' % str(percent))
    if dialog.iscanceled():
        raise StopDownload
    if percent == 100:
        d = xbmcgui.Dialog()
        ret = d.yesno(pluginname, 'Do you want to Reboot?')
        if ret:
            xbmc.log("Test-Build-Updater: Reboot XBMC", 2)
            xbmc.restart()

def cleandate(date):
    date = date.split(' ', 1)[0]
    date = '%s.%s.%s' % (date.split('-')[2], date.split('-')[1], date.split('-')[0])
    return date

def getData(url):
    r = requests.get(url)
    data = r.text
    r.connection.close()
    return data

def addDir(name, url, mode, iconimage):
    u = sys.argv[0] + "?url=" + quote_plus(url) + "&mode=" + str(mode) + "&name=" + quote_plus(name)
    item = xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
    xbmcplugin.addDirectoryItem(pluginhandle, url=u, listitem=item, isFolder=False)

def parameters_string_to_dict(parameters):
    ''' Convert parameters encoded in a URL to a dict. '''
    paramDict = {}
    if parameters:
        paramPairs = parameters[1:].split("&")
        for paramsPair in paramPairs:
            paramSplits = paramsPair.split('=')
            if (len(paramSplits)) == 2:
                paramDict[paramSplits[0]] = paramSplits[1]
    return paramDict


params = parameters_string_to_dict(sys.argv[2])
mode = params.get('mode')
url = params.get('url')
name = params.get('name')
if type(url) == type(str()):
    url = unquote_plus(url)

if mode == 'download':
    download(url, name)
else:
    categories()

xbmcplugin.endOfDirectory(pluginhandle)
